# invoke graphics driver here
#suntools()
win.graph()
library(haerdle, lib.loc="c:\\bdr")
sleep<-function(seconds) 


# CHAPTER 1

# Figure 1.9
histogram(dat.buffalo,10,0)
sleep(5)

# Figure 1.12
histogram.normal.ref(dat.mixed,0)
sleep(5)

# Figure 1.13
frequency.polygon(dat.mixed, 0.9467, 0)
sleep(5)

# Figure 1.16
par(mfrow=c(3,2))
histogram(dat.buffalo,10,0)
histogram(dat.buffalo,10,2)
histogram(dat.buffalo,10,4)
histogram(dat.buffalo,10,6)
histogram(dat.buffalo,10,8)
grid <- 1+seq(20,138,2)
est<-numeric(length(grid))
for(i in seq(0,8,2)){
cw <- histogram(dat.buffalo,10,i,FALSE)
est <- est+cw[[2]][(grid-i)%/%10]/5
}
barplot(est,grid,histo=T,inside=F, style.bar="old")
# not exactly the same
box()
sleep(5)
par(mfrow=c(1,1))

# Figure 1.19 and p.40
plot(warping(dat.mixed,1.2,10,1), type="l")
sleep(5)

# CHAPTER 2
#  WARNING - the original kde can be very slow, even on a SparcStation 1!

# Figure 2.8 (revised!)
histog(dat.buffalo,8,0, ylim=c(0,0.022), style.bar="old")
lines(kde(dat.buffalo,3,8,100))
sleep(5)

# Q2.2 (see pp.215-6)
plot(kde(dat.geyser$x, 4, h=0.1, 80), type="l")
plot(kde(dat.geyser$x, 4, h=0.3, 80), type="l")
plot(kde(dat.geyser$x, 4, h=0.6, 80), type="l")
sleep(5)

# Figure 2.11
test.kde<-kde(dat.mixed,6,0.493,100)
grid<-test.kde[,1]
true.density<- (0.6*exp(-0.5*(grid+1)^2) + 0.4*exp(-0.5*(grid-2)^2))/sqrt(2.0*pi)
density.mixed<-matrix(c(grid,true.density), length(grid), 2)
plot(density.mixed,type="n",xlab="dat.mixed",ylab="",cex=0.6)
lines(test.kde)
lines(density.mixed, lty=3)
sleep(5)

# Figure 2.12 (p.63-4)
grid<-c(0:10)/2-2
ci<-kds.ci(dat.mixed,0.493,0.5,grid,0.05)
yli<-c(0,max(ci[,5]))
plot(ci[,1], ci[,2], type="l",cex=0.6, ylim=yli)
for(i in 1:11) # not 20
{
  lines(rep(ci[i,1],2), c(ci[i,4],ci[i,5]))
  lines(ci[i,1]+c(-0.03,0.03), rep(ci[i,4],2))
  lines(ci[i,1]+c(-0.03,0.03), rep(ci[i,5],2))
}
grid<-c(0:100)/20-2
true.density<- (0.6*exp(-0.5*(grid+1)^2) + 0.4*exp(-0.5*(grid-2)^2))/sqrt(2.0*pi)
density.mixed<-matrix(c(grid,true.density), length(grid), 2)
lines(density.mixed, lty=3)
sleep(5)

# Figure 2.17
zoom <- dat.mixed[abs(dat.mixed) <=1]
warping.step(zoom,0.3,5,4)
lines(kde(zoom,4,0.3,50))
sleep(5)

# Figure 2.18
par(mfrow=c(2,2))
warping.step(dat.buffalo,10,1,4)
warping.step(dat.buffalo,10,5,4)
warping.step(dat.buffalo,10,15,4)
plot(kde(dat.buffalo,4,10,100),type="l",xlab="",ylab="",cex=0.6)
sleep(5)
par(mfrow=c(1,1))

# CHAPTER 3

# Figure 3.1
zoom <- dat.mixed[abs(dat.mixed-0.5)<=0.5]
plot(ortho.series0.1(zoom,9), type="l")
lines(ortho.series0.1(zoom,2), lty=3)
grid<-c(0:50)/50
true.density <- (0.6*exp(-0.5*(grid+1)^2) + 0.4*exp(-0.5*(grid-2)^2))/sqrt(2.0*pi)
true.density <- 50*true.density/sum(true.density)
density.mixed<-matrix(c(grid,true.density), length(grid), 2)
lines(density.mixed, lty=2)
sleep(5)

# Exercise 3.2
data <- runif(100)^2
par(mfrow=c(2,2))
plot(ortho.series0.1(data,2), ylim=c(0,4), xlab="", ylab="", type="l")
plot(ortho.series0.1(data,7), ylim=c(0,4), xlab="", ylab="", type="l")
plot(ortho.series0.1(data,20), ylim=c(0,4), xlab="", ylab="", type="l")
histogram(data,h=0.1,0,TRUE)
sleep(5)
par(mfrow=c(1,1))


# CHAPTER 4

# Figure 4.1
grid<-seq(-5,5,0.1)
true.density<- (0.6*exp(-0.5*(grid+1)^2) + 0.4*exp(-0.5*(grid-2)^2))/sqrt(2.0*pi)
density.mixed<-matrix(c(grid,true.density), length(grid), 2)
plot(density.mixed,type="l",xlab="dat.mixed",ylab="",cex=0.6)
n <- length(dat.mixed)
r <- quantile(dat.mixed, c(.25, .75))
h1 <- 1.06*sqrt(var(dat.mixed))*n^(-1/5)
h2 <- 0.79*(r[2] - r[1])*n^(-1/5)
print(h1)
print(h2)
lines(kde(dat.mixed,kernel=6,h=h1,100))
lines(kde(dat.mixed,kernel=6,h=h2,100),lty=3)

# Test of CV.Warping -- p.109 -- quite slow
cv.simul<-function(n,k,seed)
{
  .Random.seed<<-seed
  simul<-matrix(0,k,2)
  for (i in 1:k)
  {
    data<-runif(n)<=0.6
    data<-data*(rnorm(n)-1)+(rnorm(n)+2)*(1-data)
    cv<-Cv.warping(data,0.1,5,Mstart=1,Mend=20)
    simul[i,]<-cv[sum((cv[,2]==min(cv[,2]))*c(1:20)),]
  }
  simul
}
seed.simul<-c(29,29,24,52,54,1,12,25,37,25,23,0)
simulation<-cv.simul(400,100,seed.simul)
mean(simulation[,1])
sqrt(var(simulation[,1]))

# CHAPTER 5

# Figure 5.1
ord<-order(dat.geyser$x)
geyser.x<-dat.geyser$x[ord]
geyser.y<-dat.geyser$y[ord]
plot(geyser.x,geyser.y)
sleep(5)

# Figure 5.2
plot(dat.reg)
lines(dat.reg$x, dat.reg$m)
sleep(5)

# Figure 5.3
plot(geyser.x,geyser.y)
nw<-NW.kernel(geyser.x, geyser.y, 0.1)
lines(nw$grid, nw$m)
nw<-NW.kernel(geyser.x, geyser.y, 0.4)
lines(nw$grid, nw$m, lty=2)
nw<-NW.kernel(geyser.x, geyser.y, 0.8)
lines(nw$grid, nw$m, lty=3)
sleep(5)

# Figure 5.4
plot(dat.reg)
lines(dat.reg$x, dat.reg$m)
nw<-NW.kernel(dat.reg$x, dat.reg$y, 0.05)
lines(nw$grid, nw$m, lty=2)
nw<-NW.kernel(dat.reg$x, dat.reg$y, 0.10)
lines(nw$grid, nw$m, lty=3)
sleep(5)

# Example of NW.Warping
plot(dat.reg)
lines(dat.reg$x, dat.reg$m)
nw<-NW.Warping(dat.reg$x, dat.reg$y, 0.05)
lines(nw$midpoints, nw$m, lty=2)
nw<-NW.Warping(dat.reg$x, dat.reg$y, 0.10)
lines(nw$midpoints, nw$m, lty=3)
sleep(5)

# Figure 5.6
par(mfrow=c(2,2))
plot(geyser.x,geyser.y)
lines(geyser.x, k.nn(geyser.x,geyser.y,5)$m)
plot(geyser.x,geyser.y)
lines(geyser.x, k.nn(geyser.x,geyser.y,10)$m)
plot(geyser.x,geyser.y)
lines(geyser.x, k.nn(geyser.x,geyser.y,20)$m)
plot(geyser.x,geyser.y)
lines(geyser.x, k.nn(geyser.x,geyser.y,30)$m)
sleep(5)
par(mfrow=c(1,1))

# CHAPTER 6

# Figure 6.3
gcv<-G.Warpingreg(geyser.x,geyser.y,0.05,Mend=40)
aic<-G.Warpingreg(geyser.x,geyser.y,0.05, selector=1, Mend=40)
plot(aic$h, aic$score, ylim=c(29.1,29.7), type="l")
lines(gcv$h, gcv$score, lty=2)
sleep(5)

# Figure 6.4
plot(geyser.x,geyser.y)
nw<-NW.kernel(geyser.x, geyser.y, 0.65)
lines(nw$grid, nw$m)
nw<-NW.kernel(geyser.x, geyser.y, 1.75)
lines(nw$grid, nw$m, lty=2)
sleep(5)

# Figure 6.5
gw <- G.Warpingreg(dat.reg$x, dat.reg$y, 0.0025, selector=1, Mstart=7, Mend=45)
plot(gw$h, gw$score, ylim=c(0.082,0.102), type="l")
gw <- G.Warpingreg(dat.reg$x, dat.reg$y, 0.0025, selector=2, Mstart=7, Mend=45)
lines(gw$h, gw$score, lty=2)
gw <- G.Warpingreg(dat.reg$x, dat.reg$y, 0.0025, selector=3, Mstart=7, Mend=45)
lines(gw$h, gw$score, lty=3)
gw <- G.Warpingreg(dat.reg$x, dat.reg$y, 0.0025, selector=4, Mstart=7,  Mend=45)
lines(gw$h, gw$score, lty=4)
gw <- G.Warpingreg(dat.reg$x, dat.reg$y, 0.0025, selector=5, Mstart=7, Mend=45)
lines(gw$h, gw$score, lty=5)
sleep(5)

# Figure 6.6
plot(dat.reg, type="n")
lines(dat.reg$x, dat.reg$m, lty=2)
nw<-NW.kernel(dat.reg$x, dat.reg$y, 0.0625)
lines(nw$grid, nw$m, lty=1)
nw<-NW.kernel(dat.reg$x, dat.reg$y, 0.025)
lines(nw$grid, nw$m, lty=3)
sleep(5)

# Figure S.6.1
gw<-G.Warpingreg(geyser.x,geyser.y,0.05, Mstart=8, Mend=40, boundary=0)
plot(gw$h, gw$score,ylim=c(29,33), type="l")
gw<-G.Warpingreg(geyser.x,geyser.y,0.05, Mstart=8, Mend=40, boundary=0.05)
lines(gw$h, gw$score, lty=2)
gw<-G.Warpingreg(geyser.x,geyser.y,0.05, Mstart=8, Mend=40, boundary=0.1)
lines(gw$h, gw$score, lty=3)
sleep(5)

# Figure S.6.2
gw<-G.Warpingreg(dat.reg$x,dat.reg$y,0.0025, Mstart=8, Mend=40, boundary=0)
plot(gw$h, gw$score,ylim=c(0.085,0.110), type="l")
gw<-G.Warpingreg(dat.reg$x,dat.reg$y,0.0025, Mstart=8, Mend=40, boundary=0.05)
lines(gw$h, gw$score, lty=2)
gw<-G.Warpingreg(dat.reg$x,dat.reg$y,0.0025, Mstart=8, Mend=40, boundary=0.1)
lines(gw$h, gw$score, lty=3)
sleep(5)


# CHAPTER 7

# Figure 7.1
gs <- GS.Warping(geyser.x, geyser.y, h=0.4, c(0:33)/10+1.7, 5)
plot(gs$locations, gs$mMstar[1,], xlab="", ylab="", type="l")
for(i in 2:5) lines(gs$locations, gs$mMstar[i,],lty=i)
sleep(5)

# Figure 7.2
gs <- GS.Warping(dat.reg$x, dat.reg$y, h=0.1, c(1:28)/30, 5)
plot(dat.reg$x, dat.reg$m, ylim= c(-1.0,1.0), xlab="", ylab="", type="l")
for(i in 1:5) lines(gs$locations, gs$mMstar[i,]-gs$mM.large+gs$mM,lty=i)
sleep(5)

# Figures 7.3-7.5
Simul.conf.plot(geyser.x, geyser.y, h=0.65)
# This won't work! See p.190 l-6.
#Simul.conf.plot(geyser.x, geyser.y, h=1.75)
Simul.conf.plot(geyser.x, geyser.y, h=0.4)
sleep(10)

# Figures 7.6-7.8
Simul.conf.plot(dat.reg$x, dat.reg$y, h=0.065)
lines(dat.reg$x, dat.reg$m)
Simul.conf.plot(dat.reg$x, dat.reg$y, h=0.0225)
lines(dat.reg$x, dat.reg$m)
Simul.conf.plot(dat.reg$x, dat.reg$y, h=0.1)
lines(dat.reg$x, dat.reg$m)
sleep(10)
