.BG
.FN histogram
.TL
Haerdle's histogram function
.DN
computes and plots a histogram
.CS
histogram(data, h, x0, plot.type=T, ...)
.RA
.AG data
a vector of data
.AG h
bin width
.AG x0
start of first bin
.OA
.AG plot.type
If TRUE, plot the histogram
.AG ...
further options to barplot
.RT
If plot.type=F, a list of midpoint and est, the heights.
.SA
`hist', `histog', `frequency.polygon', `histogram.normal.ref'
.EX
# Figure 1.9
histogram(dat.buffalo,10,0)
 
# Figure 1.16
par(mfrow=c(3,2))
histogram(dat.buffalo,10,0)
histogram(dat.buffalo,10,2)
histogram(dat.buffalo,10,4)
histogram(dat.buffalo,10,6)
histogram(dat.buffalo,10,8)
grid <- 1+seq(20,138,2)
est<-numeric(length(grid))
for(i in seq(0,8,2)){
      cw <- histogram(dat.buffalo,10,i,FALSE)
      est <- est+cw[[2]][(grid-i)%/%10]/5
}
barplot(est,grid,histo=T,inside=F)
box()
.KW haerdle
.WR
